//
//  GBAsyncThumbCreator.h
//  GBBasicsKit
//
//  Created by Andreas Schwarz on 3/12/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <AASFilesystemTools/AASFilesystemTools.h>

@class GBAsyncThumbCreator;
@class GBThumbnailCreatorOperation;
@class GBFileItem;

// Delegate must implement this method
@interface NSObject (GBAsynchronousThumbCreatorDelegate)
- (void)asynchronousThumbnailCreator:(GBAsyncThumbCreator *)creator createdThumbnail:(CGImageRef)thumb forFile:(GBFileItem *)file nextInQueue:(GBFileItem *)nextFile;
@end



@interface GBAsyncThumbCreator : NSObject <AASQueuedObjectOperationDelegateProtocol> {
	GBThumbnailCreatorOperation *thumbnailOperation;
	
	id delegate;
	
    BOOL checkIfDifferent;
    BOOL saveToResourceFork;
    BOOL lowQuality;
    float compression;
    NSUInteger sharpening;
    NSUInteger previewSize;
}

- (NSUInteger)countLeft;

- (void)addFilesToQueue:(NSArray *)files;

- (void)clearQueue;
- (void)cancel;


@property(assign) id delegate;

@property(assign) BOOL checkIfDifferent;
@property(assign) BOOL saveToResourceFork;
@property(assign) BOOL lowQuality;
@property(assign) float compression;
@property(assign) NSUInteger sharpening;
@property(assign) NSUInteger previewSize;

@end
