//
//  GBAppPrefsData.h
//  gBrowser
//
//  Created by Andreas Schwarz on Mon Dec 24 2001.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "GBPrefsData.h"

@class GBFileItem;

@interface GBAppPrefsData : GBPrefsData {
    GBFileItem *defaultFile;
    BOOL openUntitledAuto;
    BOOL checkForUpdatesOnStartup;
    BOOL registered;
	BOOL launchedBefore;
    BOOL loadAsync;
    NSDate *installDate;
    NSDate *lastRegisterNoticeDate;
    
    // Hot keys
    NSString *zoomInHotKeyString;
    NSString *zoomOutHotKeyString;
    NSString *rotateClockwiseHotKeyString;
    NSString *rotateCounterclockwiseHotKeyString;
    NSString *recenterHotKeyString;
    NSString *fitToWindowHotKeyString;
    NSString *fitToScreenHotKeyString;
    NSString *scaleTo100HotKeyString;
    NSString *moveLeftHotKeyString;
    NSString *moveRightHotKeyString;
    NSString *moveUpHotKeyString;
    NSString *moveDownHotKeyString;
    NSString *moveUpLeftHotKeyString;
    NSString *moveUpRightHotKeyString;
    NSString *moveDownLeftHotKeyString;
    NSString *moveDownRightHotKeyString;
}

- (id)initWithUndoManager:(NSUndoManager *)um;

- (void)setOpenUntitledAuto:(BOOL)value;
- (BOOL)openUntitledAuto;

- (BOOL)setDefaultFileItem:(GBFileItem *)file;
- (GBFileItem *)defaultFileItem;

- (NSString *)defaultFileName;

- (BOOL)loadAsynchronously;
- (void)setLoadAsynchronously:(BOOL)async;


- (void)setZoomInHotKeyString:(NSString *)string;
- (NSString *)zoomInHotKeyString;
- (void)setZoomOutHotKeyString:(NSString *)string;
- (NSString *)zoomOutHotKeyString;
- (void)setRotateClockwiseHotKeyString:(NSString *)string;
- (NSString *)rotateClockwiseHotKeyString;
- (void)setRotateCounterclockwiseHotKeyString:(NSString *)string;
- (NSString *)rotateCounterclockwiseHotKeyString;
- (void)setRecenterHotKeyString:(NSString *)string;
- (NSString *)recenterHotKeyString;
- (void)setFitToWindowHotKeyString:(NSString *)string;
- (NSString *)fitToWindowHotKeyString;
- (void)setFitToScreenHotKeyString:(NSString *)string;
- (NSString *)fitToScreenHotKeyString;
- (void)setScaleTo100HotKeyString:(NSString *)string;
- (NSString *)scaleTo100HotKeyString;
- (void)setMoveLeftHotKeyString:(NSString *)string;
- (NSString *)moveLeftHotKeyString;
- (void)setMoveRightHotKeyString:(NSString *)string;
- (NSString *)moveRightHotKeyString;
- (void)setMoveUpHotKeyString:(NSString *)string;
- (NSString *)moveUpHotKeyString;
- (void)setMoveDownHotKeyString:(NSString *)string;
- (NSString *)moveDownHotKeyString;
- (void)setMoveUpLeftHotKeyString:(NSString *)string;
- (NSString *)moveUpLeftHotKeyString;
- (void)setMoveUpRightHotKeyString:(NSString *)string;
- (NSString *)moveUpRightHotKeyString;
- (void)setMoveDownLeftHotKeyString:(NSString *)string;
- (NSString *)moveDownLeftHotKeyString;
- (void)setMoveDownRightHotKeyString:(NSString *)string;
- (NSString *)moveDownRightHotKeyString;

- (BOOL)checkForUpdatesOnStartup;
- (void)setCheckForUpdatesOnStartup:(BOOL)check;

- (BOOL)launchedBefore;
- (void)setLaunchedBefore:(BOOL)first;
- (BOOL)isRegistered;
- (void)setRegistered:(BOOL)reg;

- (void)setInstallDate:(NSDate *)date;
- (NSDate *)installDate;
- (void)setLastRegisterNoticeDate:(NSDate *)date;
- (NSDate *)lastRegisterNoticeDate;


@end

extern NSString *GBDefaultFilePathChangedNotification;
extern NSString *GBOpenUntitledAutoChangedNotification;
extern NSString *GBCheckForUpdatesOnStartupChangedNotification;

extern NSString *GBLoadAsyncChangedNotification;

extern NSString *zoomInHotKeyStringChangedNotification;
extern NSString *zoomOutHotKeyStringChangedNotification;
extern NSString *rotateClockwiseHotKeyStringChangedNotification;
extern NSString *rotateCounterclockwiseHotKeyStringChangedNotification;
extern NSString *recenterHotKeyStringChangedNotification;
extern NSString *fitToWindowHotKeyStringChangedNotification;
extern NSString *fitToScreenHotKeyStringChangedNotification;
extern NSString *scaleTo100HotKeyStringChangedNotification;
extern NSString *moveLeftHotKeyStringChangedNotification;
extern NSString *moveRightHotKeyStringChangedNotification;
extern NSString *moveUpHotKeyStringChangedNotification;
extern NSString *moveDownHotKeyStringChangedNotification;
extern NSString *moveUpLeftHotKeyStringChangedNotification;
extern NSString *moveUpRightHotKeyStringChangedNotification;
extern NSString *moveDownLeftHotKeyStringChangedNotification;
extern NSString *moveDownRightHotKeyStringChangedNotification;





