//
//  GBNewPrefsWindowController.h
//  gBrowser
//
//  Created by Andreas Schwarz on Mon Mar 11 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class GBPrefsOVDataSource;
@class GBPrefsTabController;
@class GBPrefsData;
@class GBAppPrefsData;
@class GBPrefsInfoTabController;

@interface GBNewPrefsWindowController : NSWindowController {
    IBOutlet NSOutlineView *prefsOutlineView;
    IBOutlet NSTabView *tabView;
    
    GBPrefsInfoTabController *fileFilterMainTC;
    GBPrefsInfoTabController *launchMainTC;
    GBPrefsInfoTabController *previewPaneMainTC;
    GBPrefsInfoTabController *fileListMainTC;
    GBPrefsInfoTabController *imagesMainTC;
    GBPrefsInfoTabController *slideshowMainTC;
    GBPrefsInfoTabController *imageViewerMainTC;
    GBPrefsInfoTabController *hotKeysMainTC;
    GBPrefsInfoTabController *menusMainTC;
    
    NSMutableArray *controllers;
    GBPrefsTabController *currentController;
        
    BOOL appPrefs;
    
    BOOL loaded;
    
    id gBrowserDocument;
    
    GBPrefsData *prefsData;
    id delegate;
    BOOL changeDone;
}

- (id)initWithPrefs:(GBPrefsData *)prefs delegate:(id)del controllers:(NSArray *)cont;
- (id)initAsAppPrefs:(BOOL)app withPrefs:(GBPrefsData *)prefs delegate:(id)del controllers:(NSArray *)cont;

- (id)getAppPrefsData;
- (id)getPrefsData;


- (void)registerNotificationObservers;

- (void)updateForNewController;

- (BOOL)isAppPrefs;

- (Class)prefsClassForController:(GBPrefsTabController *)c;

- (id)delegate;

- (void)updateWindow;

- (void)setTabViewToTab:(NSTabViewItem *)tab;

- (void)selectFileListTab;
- (void)selectPreviewsBasicTab;
- (void)selectOpenWithTab;
- (void)selectMoveToTab;
- (void)selectFileListAppearanceTab;

- (void)selectItemWithTag:(NSInteger)tag underParent:(NSInteger)parentTag;

- (void)updatePrefsWindowFrame:(NSNotification *)notification;
- (BOOL)changeDone;

@end

@interface NSObject (GBPrefsBundlePrincipalClassProtocol)
- (NSArray *)controllers;
@end

extern NSString *GBDefaultPrefsChangedNotification;


